#include <cstdio>
#include <vector>

using namespace std;

vector<char> used(300001, false);
int cnt = 0;
vector<vector<int> > g(300001);

void dfs(int v){
    used[v] = true;
    cnt++;
    for(int i=0; i<g[v].size(); i++){
        if(!used[g[v][i]]) dfs(g[v][i]);
    }
    return;
}

int main()
{
    int n;
    scanf("%d", &n);
    int t;
    for(int i=1; i<=n; i++){
        scanf("%d", &t);
        if(t==-1) continue;
        g[t].push_back(i);
        g[i].push_back(t);
    }
    vector<vector<int> > sz(300001);
    for(int i=1; i<=n; i++){
        sz[n-g[i].size()-1].push_back(i);
        //printf("%d ", n-1-g[i].size());
    }
    /*for(int i=0; i<=n; i++){
        printf("%d : ", i);
        for(int j=0; j<sz[i].size(); j++)
            printf("%d ", sz[i]);
        printf("\n");
    }*/
    for(int i=n; i>-1; i--){
        if(sz[i].size()>=i+1) {
            for(int j=0; j<sz[i].size(); j++){
                dfs(sz[i][j]);
                if(cnt>=i+1){
                    printf("%d", i+1);
                    return 0;
                }
                cnt = 0;
            }
            printf("%d", i+1);
            return 0;
        }
    }
}
